package cn.estsh.i3plus.ext.mes.pcn.pojo.context;

import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import cn.estsh.i3plus.pojo.mes.bean.MesContainerPackageDetail;
import cn.estsh.i3plus.pojo.mes.bean.MesContainerSnStation;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.util.StringUtils;

import java.io.Serializable;

/**
 * 生产过程上下文对象-容器条码上料明细
 */
@Data
public class MesContainerPackageDetailContext extends MesContainerPackageDetail implements Serializable {

    private static final long serialVersionUID = 3519172978836073435L;

    @ApiParam(name = "站点")
    private String station;

    @ApiParam("顺序号")
    private Integer seq;

    @ApiParam(value = "主表创建日期")
    private String createDatetime2Package;

    @ApiParam("库存")
    private Double remainQty;

    public MesContainerPackageDetailContext() {}

    public MesContainerPackageDetailContext(MesContainerPackageDetail containerPackageDetail) {
        BeanUtils.copyProperties(containerPackageDetail, this);
    }

    public MesContainerPackageDetailContext station(MesContainerSnStation containerSnStation) {
        this.station = containerSnStation.getStation();
        this.seq = !StringUtils.isEmpty(containerSnStation.getSeq()) ? containerSnStation.getSeq() : MesPcnExtConstWords.ZERO;
        this.createDatetime2Package = containerSnStation.getCreateDatetime();
        return this;
    }

    public MesContainerPackageDetailContext remainQty(String remainQty) {
        return remainQty(!StringUtils.isEmpty(remainQty) ? new Double(remainQty) : new Double(MesPcnExtConstWords.ZERO));
    }

    public MesContainerPackageDetailContext remainQty(Double remainQty) {
        this.remainQty = remainQty;
        return this;
    }

}
